<?php
/**
 * @copyright	Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access
defined('_JEXEC') or die;

use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\CMS\Factory;

class plgVisformsPlgmaster extends CMSPlugin
{
    public function __construct(& $subject, $config) {
        parent::__construct($subject, $config);
        //load the translation
        $this->loadLanguage();
    }
	// NOTE: this plugin requires Visforms Base and Visforms Subscription 4.1.0 (or higher) !!
	public function onVisformsFormPrepare($context, $form, $menuparams) {
		// Skip plugin if context is wrong
		$allowedContexts = array('com_visforms.form', 'mod_visforms.form', 'plg_vfformview.form');
		if (!in_array($context, $allowedContexts)) {
			return true;
		}
		$app = Factory::getApplication();
		// only perform action, if we are in front end
		if ($app->isClient('administrator')) {
			return true;
		}
		//if $form->parentFormId is not set, Visforms or Content Plugin Form View version is to old
		if (!isset($form->parentFormId)) {
			return true;
		}
		// get value of id attribute of the form which is going to be displayed
		$parentFormId = $form->parentFormId;
		// add custom submit handler function to the form
		$script = 'jQuery(document).ready(function () {
			//add custom submit action function to form
			window["' . $parentFormId . 'SubmitAction"] = function (form) {
			// your code in here
			//return false to prevent form from being submitted, return true, if submithandler performs another action but form should be send
				return true;
			};
		});';
		Factory::getDocument()->addScriptDeclaration($script);
		// End: add custom submit handler function to the form
	}

	public function onVisformsBeforeFormSave($context, $form, $fields)
	{
		// Skip plugin if context is wrong
		$allowedContexts = array('com_visforms.form', 'mod_visforms.form', 'plg_vfformview.form');
		if (!in_array($context, $allowedContexts)) {
			return true;
		}
		$app = Factory::getApplication();
		// only perform action, if we are in front end
		if ($app->isClient('administrator')) {
			return true;
		}
		// your code in here
		return true;
	}
}